import IFakers
from Interface import Attribute

class IZFakeProduct( IFakers.IFakeItem ):
    """A Zope fake product, designed to be a child of something that
    implements IZFakeFolder or IZFakeOrderedFolder."""

    def getIconURL(self):
        """returns the Zope path to an icon that can represent this
        fake product."""

    def setIconURL(self, pathString, mfunc=None):
        """sets the Zope icon URL for this product."""

    icon=Attribute("icon","The URL of the icon, from the Zope root but without a beginning slash")

class IZFakeFolder( IFakers.IFakeFolder ):
    """a Zope fake folder, designed to hold objects implementing
    IZFakeProduct"""

    def getAcquiredItems(self, metatypes=None, interfaces=None):
        """returns tuple of acquired items in folder, limited to those
        of type metatype(s) if specified individually or in a tuple,
        or limited to those implementing one or more given interface
        (individual or tuple).  If both are given, at item matching
        either criterian will be included."""

    def getAcquiredKeyValTuples(self, metatypes=None, interfaces=None):
        """returns a list of tuples, in which each tuple is the id and
        actual acquired object of an item in the folder.  Limited to
        those of type metatype(s) if specified individually or in a
        tuple, or limited to those implementing one or more given
        interface (individual or tuple).  If both are given, at item
        matching either criterian will be included."""

    def getAcquiredItemById(self, id, marker=None):
        """pass in a string id, get the associated object or marker if not
        found"""

    def getAcquiredItemByIdPath(self, path):
        """given a list of ids, tries to walk down it, finding the
        child known by the first id in the current object, the
        grandchild known by the second id in the child, and so on.  An
        error is raised if the path does not resolve to an object.
        Final object is acquired by all parents."""

    def getAcquiredItemsByIds(self, ids=[]):
        """returns objects of given ids"""

class IZOrderedFakeFolder( IZFakeFolder, IFakers.IOrderedFakeFolder ):
    """a Zope fake folder that can have it's contents ordered"""
