"""This is a mix-in and should not be used by itself"""

from OFS.SimpleItem import SimpleItem
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from App.Management import Navigation #, Tabs
import Fakers

class ZFakeItem(Fakers.FakeItem, SimpleItem, Navigation):
    """mix-in not intended to be used by itself"""

    def __init__(self, id, title=""):
        self.setId(id)
        self.setTitle(title)
        # Fakers.FakeItem.__init__(self, id, title)

    security = ClassSecurityInfo()

    manage_options=SimpleItem.manage_options

    security.declareProtected( 'View', 'getTitle' )
    security.declareProtected( 'View', 'title_or_id' )
    security.declareProtected( 'View', 'title_and_id' )
    security.declareProtected( 'View', 'id_and_title' )
    security.declareProtected( 'View', 'getId' )
    security.declarePrivate( 'checkId' )
    security.declareProtected( 'Manage properties', 'setTitle' )
    security.declareProtected( 'Manage properties', 'setId' )
    security.declareProtected( 'Manage properties', '_setId' )
    security.declareProtected( 'View', 'id' )

    security.declarePrivate( '_check_path' ) # currently unnecessary
    def _check_path(self,path,mfunc=None):
        """pass in a path, have it validated as bad (empty, not found, or not
        a folder) (0) or ok (1).  The optional mfunc thing is a trick to let the method return a clear on-off numeric success message, while allowing it also to communicate some human-readable messages should we want them.  Just assign a variable in your local scope to an array, pass it along with the path, and then the next time you look at it, through the magic of passing by reference, it might have a message from this function.  This particular function will currently only give you a message if it encounters a bad path."""
        if not path:
           if mfunc:mfunc("Empty path ignored" )
           return 0
        if path[-1] == '/':
           if len(path) == 1:
              return 1
           else:
              path = path[:-1]
        try:
            leaf_object = self.unrestrictedTraverse(path)
        except:
            if mfunc:mfunc("The path %s was not found, so ignored" % path)
            return 0
        if not getattr(leaf_object.aq_base,'isAnObjectManager', None):
            if mfunc:mfunc( "Paths must end in a container: %s does not." % path )
        return 1


InitializeClass(ZFakeItem)
