"""an ordered fake folder for fake products"""

#from OFS.SimpleItem import SimpleItem # Item
#from App.Management import Navigation, Tabs
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass, DTMLFile
import Fakers, ZFakeItem, ZFakeProduct, ZFakeFolder, IZFakers


class ZOrderedFakeFolder( ZFakeFolder.ZFakeFolder, Fakers.OrderedFakeFolder ):
    """an ordered fake folder for fake products"""

    def __init__(self, id, title=""):
        ZFakeFolder.ZFakeFolder.__init__(self, id, title)

    __implements__=IZFakers.IZOrderedFakeFolder

    meta_type="Ordered Fake Folder"

    manage_options=(
        ZFakeFolder.ZFakeFolder.specific_manage_options + ZFakeFolder.ZFakeFolder.generic_manage_options
        )

    security = ClassSecurityInfo()

    security.declareProtected( 'Manage properties', 'moveItemsUpByIds' )
    security.declareProtected( 'Manage properties', 'moveItemsDownByIds' )
    security.declareProtected( 'Manage properties', 'moveItemsToTopByIds' )
    security.declareProtected( 'Manage properties', 'moveItemsToBottomByIds' )

    # manage_main =
    manage_contents = DTMLFile('dtml/manage_contents', globals())

    security.declareProtected( 'Manage properties', 'manage_moveItemsUp' )
    def manage_moveItemsUp(self, ids=[], REQUEST=None):
        """moves selected items up by one, if possible, in the
        folder; returns HTML or text confirmation"""
        if type(ids) is type(''): ids=[ids]
        if not ids:
            if REQUEST is not None:
                return self.manage_contents(self, REQUEST, message='No items were specified!')
            else: return 'No items were specified!'
        attempt=len(ids)
        self.moveItemsUpByIds(ids)
        if REQUEST is not None:
            return self.manage_contents(self, REQUEST, message="%d items moved up." % attempt)
        return "%d items moved up." % attempt

    security.declareProtected( 'Manage properties', 'manage_moveItemsDown' )
    def manage_moveItemsDown(self, ids=[], REQUEST=None):
        """moves selected items down by one, if possible, in the
        folder; returns HTML or text confirmation"""
        if type(ids) is type(''): ids=[ids]
        if not ids:
            if REQUEST is not None:
                return self.manage_contents(self, REQUEST, message='No items were specified!')
            else: return 'No items were specified!'
        attempt=len(ids)
        self.moveItemsDownByIds(ids)
        if REQUEST is not None:
            return self.manage_contents(self, REQUEST, message="%d items moved down." % attempt)
        return "%d items moved down." % attempt

    security.declareProtected( 'Manage properties', 'manage_moveItemsToTop' )
    def manage_moveItemsToTop(self, ids=[], REQUEST=None):
        """moves selected items to top of folder; returns HTML or
        text confirmation"""
        if type(ids) is type(''): ids=[ids]
        if not ids:
            if REQUEST is not None:
                return self.manage_contents(self, REQUEST, message='No items were specified!')
            else: return 'No items were specified!'
        attempt=self.moveItemsToTopByIds(ids)
        if REQUEST is not None:
            return self.manage_contents(self, REQUEST, message="%d items moved to top." % attempt)
        return "%d items moved to top." % attempt

    security.declareProtected( 'Manage properties', 'manage_moveItemsToBottom' )
    def manage_moveItemsToBottom(self, ids=[], REQUEST=None):
        """moves selected items to bottom of folder; returns HTML or
        text confirmation"""
        if type(ids) is type(''): ids=[ids]
        if not ids:
            if REQUEST is not None:
                return self.manage_contents(self, REQUEST, message='No items were specified!')
            else: return 'No items specified'
        attempt=self.moveItemsToBottomByIds(ids)
        if REQUEST is not None:
            return self.manage_contents(self, REQUEST, message="%d items moved to bottom." % attempt)
        return "%d items moved to bottom." % attempt

manage_addZOrderedFakeFolderForm=DTMLFile('dtml/addZOrderedFakeFolder', globals())

def manage_addZOrderedFakeFolder(self, id, REQUEST=None, title="", **ignored):
    """Constructor for ZFakeFolder"""
    obj = ZOrderedFakeFolder(id, title)
    #obj.setId(str(id))
    #if title: obj.setTitle(title)
    self._setObject(id, obj)
    if REQUEST:
        return self.manage_main(self,REQUEST, update_menu=1)
    else:
        return 1

constructors = (
  ('manage_addZOrderedFakeFolderForm', DTMLFile('www/addZOrderedFakeFolder', globals())),
  ('manage_addZOrderedFakeFolder', manage_addZOrderedFakeFolder),
)


InitializeClass(ZOrderedFakeFolder)
